// LspSpiLib.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"

#pragma warning(disable: 4001)      /* Single-line comment */

#pragma comment( lib, "Ws2_32.lib" )

#include "precomp.h"

HINSTANCE HDllInstance;
DWORD TlsIndex = 0xFFFFFFFF;

BOOL APIENTRY DllMain( IN HINSTANCE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
   switch (ul_reason_for_call) {

   case DLL_PROCESS_ATTACH:
      DTHookInitialize();
      InitializeCriticalSection(&g_InitCriticalSection);
      HDllInstance = hModule;
      TlsIndex = TlsAlloc();
      break;

   case DLL_THREAD_ATTACH:
      break;

   case DLL_THREAD_DETACH:
      break;

   case DLL_PROCESS_DETACH:
      // Note that lpvReserved will be NULL if the detach is due to
      // a FreeLibrary() call, and non-NULL if the detach is due to
      // process cleanup.
      //

      if( lpReserved == NULL ) {
          if (TlsIndex!=0xFFFFFFFF) {
              TlsFree (TlsIndex);
              TlsIndex = 0xFFFFFFFF;
          }
      }

      DeleteCriticalSection(&g_InitCriticalSection);
      DTHookShutdown();
      break;
   }


   return(TRUE);
}

